<?php if (!defined('ABSPATH')) {
    die;
}
// Cannot access pages directly.

function brifa_about_page_metabox($options){

    $page_id = 0;
    if ( isset( $_REQUEST['post'] ) || isset( $_REQUEST['post_ID'] ) ) {
        $page_id = empty( $_REQUEST['post_ID'] ) ? $_REQUEST['post'] : $_REQUEST['post_ID'];
    }

    $current_page_template = get_post_meta( $page_id, '_wp_page_template', true );
    if ( ! in_array( $current_page_template, array( 'page-templates/about.php' ) ) ) {
        return $options;
    }

    $options[] = array(
        'id'        => 'brifa-page-about',
        'title'     => __( 'About page content first', 'brifa' ),
        'post_type' => 'page',
        'context'   => 'normal',
        'priority'  => 'default',
        'sections'  => array(
            array(
                'name'   => 'about_page_meta',
                'icon'   => 'fa fa-image',
                'fields' => array(
                    array(
                        'id'      => 'page-left-one',
                        'type'    => 'image',
                        'title'   => __( 'Left image one', 'brifa' ),
                        'add_title'   => __( 'Add Image', 'brifa' ),
                    ),
                    array(
                        'id'      => 'page-left-two',
                        'type'    => 'image',
                        'title'   => __( 'Left image two', 'brifa' ),
                        'add_title'   => __( 'Add Image', 'brifa' ),
                    ),
                    array(
                        'id'      => 'page-left-three',
                        'type'    => 'image',
                        'title'   => __( 'Left image three', 'brifa' ),
                        'add_title'   => __( 'Add Image', 'brifa' ),
                    ),
                    array(
                        'id'      => 'page-left-title',
                        'type'    => 'text',
                        'title'   => __( 'Left image Right Title', 'brifa' ),
                    ),

                    array(
                        'id'      => 'page-left-content',
                        'type'    => 'textarea',
                        'title'   => __( 'Left image Right Content', 'brifa' ),
                    ),



                )
            )
        )
    );


     $options[] = array(
        'id'        => 'brifa-page-about-two',
        'title'     => __( 'About page content Second', 'brifa' ),
        'post_type' => 'page',
        'context'   => 'normal',
        'priority'  => 'default',
        'sections'  => array(
            array(
                'name'   => 'about_page_meta_two',
                'icon'   => 'fa fa-image',
                'fields' => array(
                    array(
                        'id'      => 'page-right-one',
                        'type'    => 'image',
                        'title'   => __( 'Right image one', 'brifa' ),
                        'add_title'   => __( 'Add Image', 'brifa' ),
                    ),
                    array(
                        'id'      => 'page-right-two',
                        'type'    => 'image',
                        'title'   => __( 'Right image two', 'brifa' ),
                        'add_title'   => __( 'Add Image', 'brifa' ),
                    ),
                    array(
                        'id'      => 'page-right-three',
                        'type'    => 'image',
                        'title'   => __( 'Right image three', 'brifa' ),
                        'add_title'   => __( 'Add Image', 'brifa' ),
                    ),
                    array(
                        'id'      => 'page-right-title',
                        'type'    => 'text',
                        'title'   => __( 'Right image Right Title', 'brifa' ),
                    ),

                    array(
                        'id'      => 'page-right-content',
                        'type'    => 'textarea',
                        'title'   => __( 'Left image Right Content', 'brifa' ),
                    ),



                )
            )
        )
    );


     $options[] = array(
        'id'        => 'brifa-about-teams',
        'title'     => __( 'About Team ', 'brifa' ),
        'post_type' => 'page',
        'context'   => 'normal',
        'priority'  => 'default',
        'sections'  => array(

            array(
                'name'     => 'brifa-team-about',
                'icon'   => 'fa fa-image',
                'fields' => array(
                    array(
                        'id'    => 'team_member_title',
                        'title'   => __( 'Team Title', 'brifa' ),
                        'type'    => 'fieldset',
                        'fields'=>array(
                            array(
                              'id'    => 'team_title_about',
                              'type'  => 'text',
                              'title' => __( 'Team Member Title', 'brifa' ),
                            ),
                            array(
                              'id'    => 'team_title_sub',
                              'type'  => 'textarea',
                              'title' => __( 'Team Member Sub Title', 'brifa' ),
                            ),
                        )
                    ),
                    array(
                        'id'    => 'team_member_about',
                        'title'   => __( 'Select Teams', 'brifa' ),
                        'type'    => 'group',
                        'button_title'    => __('New Team Member','brifa'),
                        'accordion_title' => __('Add New Team Member','brifa'),
                        'fields'=>array(
                            array(
                                'id'    => 'brifa_team_img',
                                'title'   => __( 'Member Image', 'brifa' ),
                                'type'    => 'image',
                            ),
                            array(
                              'id'    => 'team_name',
                              'type'  => 'text',
                              'title' => __( 'Member Name', 'brifa' ),
                            ),
                            array(
                              'id'    => 'team_title',
                              'type'  => 'text',
                              'title' => __( 'Member Title', 'brifa' ),
                            ),
                            array(
                                'id'        => 'social_profiles',
                                'type'      => 'fieldset',
                                'title'     => __( 'Social Profiles', 'brifa' ),
                                'fields'    => array(

                                    array(
                                        'id'    => 'facebook',
                                        'type'  => 'text',
                                        'title' => __( 'Facebook', 'brifa' ),
                                    ),
                                    array(
                                        'id'    => 'twitter',
                                        'type'  => 'text',
                                        'title' => __( 'Twitter', 'brifa' ),
                                    ),
                                    array(
                                        'id'    => 'google_plus',
                                        'type'  => 'text',
                                        'title' => __( 'Google Plus', 'brifa' ),
                                    ),

                                ),
                            ),

                        )
                    ),


                ),
               
            ),

        )
    );

    return $options;
}
add_filter( 'cs_metabox_options', 'brifa_about_page_metabox' );