<?php
/**
 * Template Name: Portfolio Page
 */

get_header();


 $brifa_page_meta = get_post_meta(get_the_ID(),'page-upload-bg',true);
 $brifa_custom_bg = wp_get_attachment_image_src( $brifa_page_meta['page-image'], 'full' );

 $brifa_section_meta = get_post_meta(get_the_ID(),'brifa-section-gallery',true);

 ?>

 <!--single page banner-->
    <header class="single-page-banner banner-blog" <?php if ( !empty( $brifa_custom_bg ) ): ?>style="background-image: url(<?php echo esc_url( $brifa_custom_bg[0] ); ?>);" <?php endif; ?>>

        <div class="container">
            <div class="page-banner-txt">

                <?php if(function_exists('bcn_display'))
                    {
                        bcn_display();
                    };
                    ?>
            </div><!--/.page-banner-txt-->
        </div><!--/.container-->
    </header>
    <!--/.single page banner-->

    <?php the_content(); ?>

    <?php
    $brifa_gallery_items   = $brifa_section_meta['portfolio'];
    $brifa_item_categories = [];
    foreach ( $brifa_gallery_items as $brifa_gallery_item ) {
        $brifa_gallery_item_categories = explode( ",", $brifa_gallery_item['categories'] );
        foreach ( $brifa_gallery_item_categories as $brifa_gallery_item_category ) {
            $brifa_gallery_item_category = trim( $brifa_gallery_item_category );
            if ( ! in_array( $brifa_gallery_item_category, $brifa_item_categories ) ) {
                array_push( $brifa_item_categories, $brifa_gallery_item_category );
            }
        }
    }

    ?>

<!--portfolio page-->
    <section class="portfolio-page">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <!--filter-->
                    <div class="button-group filter-button-group">

                        <button class="is-checked"  data-filter="*"> <?php _e( 'All', 'brifa' ) ?></button>
                        <?php
                        foreach ( $brifa_item_categories as $brifa_item_category ):
                            ?>
                           <button data-filter=".<?php echo esc_attr( $brifa_item_category ); ?>"><?php echo esc_html( $brifa_item_category ); ?></button>
                            
                        <?php
                        endforeach;
                        ?>
                    </div>
                    <!-- /filter-->
                </div>

                <div class="w-100"></div>
                <div class="col-md-12">
                    <div class="grid popup-gallery">
                        <div class="row">

                          <?php
                          foreach ( $brifa_gallery_items as $brifa_gallery_item ):
                              $brifa_item_class = str_replace( ",", " ", $brifa_gallery_item['categories'] );
                              $brifa_item_image_id = $brifa_gallery_item['image'];
                              $brifa_item_thumbnail = wp_get_attachment_image_src($brifa_item_image_id,'medium');
                              $brifa_item_large = wp_get_attachment_image_src($brifa_item_image_id,'large');
                              $brifa_item_categories_array = explode(",",$brifa_gallery_item['categories']);
                          ?>

                        <div class="col-md-4 grid-item <?php echo esc_attr( $brifa_item_class ); ?>" data-category="<?php echo esc_attr( $brifa_item_class ); ?>">
                                <div class="item-inner">
                                    <img src="<?php echo esc_url($brifa_item_thumbnail[0]); ?>" alt="<?php echo esc_html($brifa_gallery_item['title']) ?>"/>
                                    <div class="overlay">
                                        <div class="view-list">
                                           <a href="<?php echo esc_url($brifa_item_large[0]); ?>" data-toggle="lightbox" data-gallery="example-gallery" class="item popup-link">
                                               <i class="far fa-plus-square fa-2x"></i>
                                           </a>
                                           <a href="<?php echo esc_url($brifa_gallery_item['port_link']) ?>" target="_blank"><i class="fas fa-link fa-2x"></i></a>
                                        </div>
                                    </div>           
                                </div><!--/.item-inner-->
                                <div class="portfolio-info">
                                    <p><?php
                                            foreach($brifa_item_categories_array as $brifa_item_category):
                                            printf("<span>%s</span>",trim($brifa_item_category));
                                            endforeach;
                                            ?></p>
                                    <h2><?php echo esc_html($brifa_gallery_item['title']) ?></h2>
                                </div>
                            </div>
                          <?php
                          endforeach;
                          ?>

                        </div>
                    </div><!--/.grid-->
                </div>

            </div>
        </div><!--/.container-->
    </section>
    <!--/.portfolio page-->

    <?php get_footer(); ?>