<?php
// require_once get_theme_file_path( "/lib/csf/cs-framework.php" );
require_once get_theme_file_path( "/inc/tgm.php" );
require_once get_theme_file_path( "/inc/metaboxes/section.php" );
require_once get_theme_file_path( "/inc/metaboxes/page.php" );
require_once get_theme_file_path( "/inc/metaboxes/section-banner.php" );
require_once get_theme_file_path( "/inc/metaboxes/section-features.php" );
require_once get_theme_file_path( "/inc/metaboxes/section-services.php" );
require_once get_theme_file_path( "/inc/metaboxes/section-fun_fact.php" );
require_once get_theme_file_path( "/inc/metaboxes/section-teams.php" );
require_once get_theme_file_path( "/inc/metaboxes/section-testimonial.php" );
require_once get_theme_file_path( "/inc/metaboxes/section-pricing.php" );
require_once get_theme_file_path( "/inc/metaboxes/header-bg.php" );
require_once get_theme_file_path( "/inc/metaboxes/about-metabox.php" );
require_once get_theme_file_path( "/inc/metaboxes/service-metabox.php" );
require_once get_theme_file_path( "/inc/metaboxes/portfolio-metabox.php" );
// require_once get_theme_file_path( "/inc/metaboxes/section-blog.php" );
require_once( get_template_directory() .'/inc/better-comments.php' );
require_once get_theme_file_path( "/inc/one-click-demo-importer.php" );



define( 'CS_ACTIVE_FRAMEWORK', false ); // default true
define( 'CS_ACTIVE_METABOX', true ); // default true
define( 'CS_ACTIVE_TAXONOMY', true ); // default true
define( 'CS_ACTIVE_SHORTCODE', false ); // default true
define( 'CS_ACTIVE_CUSTOMIZE', false ); // default true




function brifa_theme_setup() {
	load_theme_textdomain( 'brifa', get_template_directory() . "/languages" );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'title-tags' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'html5', array(
		'search-form',
		'comment-form',
		'gallery',
		'caption',
		'comment-list'
	) );
	add_theme_support( 'custom-logo' );

    add_image_size( 'custom-size-popular', 100, 100 );
    add_image_size( 'custom-size-single', 750, 300 );

    $args = array(
        'default-image' => get_template_directory_uri() . '/assests/img/banner.jpg',
    );
    add_theme_support( 'custom-header', $args );

	register_nav_menu( 'top', __( 'Main Menu', 'brifa' ) );
    register_nav_menus( array(
        "footer-menus"   => __( "Footer Menu", "brifa" ),
        "footer-links" => __( "Footer quick links", "brifa" ),

    ) );
	
    if ( ! isset( $content_width ) ) {
        $content_width = 1170;
    }
}

add_action( 'after_setup_theme', 'brifa_theme_setup' );


add_filter( 'wp_title', 'brifa_wp_title' );
function brifa_wp_title( $title )
{
  if ( empty( $title ) && ( is_home() || is_front_page() ) ) {
    $title = __( 'Home', 'brifa' ) . ' | ' . get_bloginfo( 'description' );
  }
  return $title;
}

function brifa_upload_svg_media($mimes) {
 $mimes['svg'] = 'image/svg+xml';
 return $mimes;
}
add_filter('upload_mimes', 'brifa_upload_svg_media');

function brifa_custom_body_class_for_nav( $classes ) {
    if( is_page_template('page-templates/landing.php') )
        $classes[] = 'front_tag_nav';
    return $classes;
}
add_filter( 'body_class', 'brifa_custom_body_class_for_nav' );

function brifa_assests(){
	wp_enqueue_style( 'bootstrap-css', get_template_directory_uri() . '/assests/css/bootstrap.min.css', null, '4.0.0' );
	wp_enqueue_style( 'animate-css', get_template_directory_uri() . '/assests/css/animate.css', null, '3.6.0' );
	wp_enqueue_style( 'normalize-css', get_template_directory_uri() . '/assests/css/normalize.css', null, '4.1.1' );
	wp_enqueue_style( 'swiper-css', get_template_directory_uri() . '/assests/css/swiper.css', null, '4.4.1' );
	wp_enqueue_style( 'magnific-css', get_template_directory_uri() . '/assests/css/magnific-popup.css', null, '1.0' );
	wp_enqueue_style( 'brifa-fonts', '//fonts.googleapis.com/css?family=Poppins:400,500,600,700"' );
	wp_enqueue_style( 'brifa-fonts2', '//fonts.googleapis.com/css?family=Montserrat:400,500,600,700"' );
	wp_enqueue_style( 'fontawesome-css', '//use.fontawesome.com/releases/v5.0.8/css/all.css"' );
	wp_enqueue_style( 'brifa-style', get_template_directory_uri() . '/assests/css/style.css', null, '1.0' );

	wp_enqueue_script( 'modernizr-js', get_template_directory_uri() . '/assests/js/vendor/modernizr.js', '2.8.3', false );
	wp_enqueue_script( 'popper-js', get_template_directory_uri() . '/assests/js/vendor/popper.min.js', array( 'jquery' ), '4.0', true );
	wp_enqueue_script( 'bootstrap-js', get_template_directory_uri() . '/assests/js/vendor/bootstrap.min.js', array( 'jquery' ), '4.0.0', true );
	wp_enqueue_script( 'wow-js', get_template_directory_uri() . '/assests/js/vendor/wow-min.js', array( 'jquery' ), '1.1.3', true );
	wp_enqueue_script( 'swiper-js', get_template_directory_uri() . '/assests/js/vendor/swiper.js', array( 'jquery' ), '4.4.1', true );
	wp_enqueue_script( 'counter-js', get_template_directory_uri() . '/assests/js/vendor/counter.js', array( 'jquery' ), '1.0', true );
    wp_enqueue_script( 'magnifice', get_template_directory_uri() . '/assests/js/vendor/magnifice-js.js', array( 'jquery' ), '1.1.0', true );
    wp_enqueue_script( 'isotop', get_template_directory_uri() . '/assests/js/vendor/isotop.js', array( 'jquery' ), '3.0.5', true );
    wp_enqueue_script( 'easing-js', get_template_directory_uri() . '/assests/js/vendor/easing.js', array( 'jquery' ), '3.0.5', true );
    if (is_singular() ){
        wp_enqueue_script("comment-reply");
    }

    wp_enqueue_script( 'brifa-main', get_template_directory_uri() . '/assests/js/main.js', array( 'jquery' ), '1.0', true );



}
add_action('wp_enqueue_scripts','brifa_assests');


add_action( 'template_redirect', function(){
    ob_start( function( $buffer ){
        $buffer = str_replace( array( 'type="text/javascript"', "type='text/javascript'" ), '', $buffer );
        
        // Also works with other attributes...
        $buffer = str_replace( array( 'type="text/css"', "type='text/css'" ), '', $buffer );
        $buffer = str_replace( array( 'frameborder="0"', "frameborder='0'" ), '', $buffer );
        $buffer = str_replace( array( 'scrolling="no"', "scrolling='no'" ), '', $buffer );
        
        return $buffer;
    });
});



add_filter( 'get_custom_logo', 'brifa_custom_logo' );
// Filter the output of logo to fix Googles Error about itemprop logo
function brifa_custom_logo() {
    $custom_logo_id = get_theme_mod( 'custom_logo' );
    $html = sprintf( '<a href="%1$s" class="navbar-brand" rel="home">%2$s</a>',
            esc_url( home_url( '/' ) ),
            wp_get_attachment_image( $custom_logo_id, 'full', false, array(
                'class'    => 'custom-logo',
            ) )
        );
    return $html;   
}


class brifaNavwalker extends Walker_Nav_Menu
{
    public function start_lvl( &$output, $depth = 0, $args = array() ) {
        $indent = str_repeat("\t", $depth);
        $output .= "\n$indent<div class=\"dropdown-menu\">\n";
    }
    public function end_lvl( &$output, $depth = 0, $args = array() ) {
        $indent = str_repeat("\t", $depth);
        $output .= "$indent</div>\n";
    }
    public function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
        $indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
        $classes = empty( $item->classes ) ? array() : (array) $item->classes;
        $classes[] = 'menu-item-' . $item->ID;

        $class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item, $args, $depth ) );
        // New
        $class_names .= ' nav-item';
        
        if (in_array('menu-item-has-children', $classes)) {
            $class_names .= ' dropdown';
        }
        if (in_array('current-menu-item', $classes)) {
            $class_names .= ' active';
        }
        //
        $class_names = $class_names ? ' class="' . esc_attr( $class_names ) . '"' : '';
        $id = apply_filters( 'nav_menu_item_id', 'menu-item-'. $item->ID, $item, $args, $depth );
        $id = $id ? ' id="' . esc_attr( $id ) . '"' : '';
        // New
        if ($depth === 0) {
            $output .= $indent . '<li' . $id . $class_names .'>';
        }
        //
        // $output .= $indent . '<li' . $id . $class_names .'>';
        $atts = array();
        $atts['title']  = ! empty( $item->attr_title ) ? $item->attr_title : '';
        $atts['target'] = ! empty( $item->target )     ? $item->target     : '';
        $atts['rel']    = ! empty( $item->xfn )        ? $item->xfn        : '';
        $atts['href']   = ! empty( $item->url )        ? $item->url        : '';
        // New
        if ($depth === 0) {
            $atts['class'] = 'nav-link';
        }
        if ($depth === 0 && in_array('menu-item-has-children', $classes)) {
            $atts['class']       .= ' dropdown-toggle';
            $atts['data-toggle']  = 'dropdown';
        }
        if ($depth > 0) {
            $manual_class = array_values($classes)[0] .' '. 'dropdown-item';
            $atts ['class']= $manual_class;
        }
        if (in_array('current-menu-item', $item->classes)) {
            $atts['class'] .= ' active';
        }

        $atts = apply_filters( 'nav_menu_link_attributes', $atts, $item, $args, $depth );
        $attributes = '';
        foreach ( $atts as $attr => $value ) {
            if ( ! empty( $value ) ) {
                $value = ( 'href' === $attr ) ? esc_url( $value ) : esc_attr( $value );
                $attributes .= ' ' . $attr . '="' . $value . '"';
            }
        }
        $item_output = $args->before;

        $item_output .= '<a'. $attributes .'>';
        /** This filter is documented in wp-includes/post-template.php */
        $item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after;
        $item_output .= '</a>';
        $item_output .= $args->after;

        $output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
    }

    public function end_el( &$output, $item, $depth = 0, $args = array() ) {
        if ($depth === 0) {
            $output .= "</li>\n";
        }
    }
}


function brifa_add_cat_class( $result ) {

  $class = strtolower( $result[2] );
  $class = str_replace( ' ', '-', $class );

  $replacement = sprintf( ' class="cat">%s</a>', $class, $result[2] );
  return preg_replace( '#>([^<]+)</a>#Uis', $replacement, $result[0] );

}

function brifa_category_slug( $html ) {

  $search  = '#<a[^>]+(\>([^<]+)\</a>)#Uuis';
  $html = preg_replace_callback( $search, 'brifa_add_cat_class', $html );

  return $html;
}

add_filter( 'the_category', 'brifa_category_slug', 99, 1 );



function brifa_widgets() {
    register_sidebar( array(
        'name'          => __( 'Footer Description', 'brifa' ),
        'id'            => 'footer-desc',
        'description'   => __( 'Add footer description and footer logo', 'brifa' ),
        'before_widget' => '<div class="widget-inside">',
        'after_widget'  => '</div>',
        'before_title'  => '<h3>',
        'after_title'   => '</h3>',
    ) );

    register_sidebar( array(
        'name'          => __( 'Footer Menu', 'brifa' ),
        'id'            => 'footer-menu',
        'description'   => __( 'Add footer Menu', 'brifa' ),
        'before_widget' => '<div class="footer-link">',
        'after_widget'  => '</div>',
        'before_title'  => '<h3>',
        'after_title'   => '</h3>',
    ) );

    register_sidebar( array(
        'name'          => __( 'Footer Quick Links', 'brifa' ),
        'id'            => 'footer-links',
        'description'   => __( 'Add footer Quick Links', 'brifa' ),
        'before_widget' => '<div class="footer-link">',
        'after_widget'  => '</div>',
        'before_title'  => '<h3>',
        'after_title'   => '</h3>',
    ) );


    register_sidebar( array(
        'name'          => __( 'Footer Newsletter', 'brifa' ),
        'id'            => 'footer-news',
        'description'   => __( 'Add footer Newsletter form', 'brifa' ),
        'before_widget' => '<div class="footer-input">',
        'after_widget'  => '</div>',
        'before_title'  => '<h3>',
        'after_title'   => '</h3>',
    ) );


    register_sidebar( array(
        'name'          => __( 'Footer Social', 'brifa' ),
        'id'            => 'footer-social',
        'description'   => __( 'Add footer Social Link', 'brifa' ),
        'before_widget' => '<div class="follow-link">',
        'after_widget'  => '</div>',
        'before_title'  => '<h3>',
        'after_title'   => '</h3>',
    ) );


    register_sidebar( array(
        'name'          => __( 'Copyright Text', 'brifa' ),
        'id'            => 'copyright',
        'description'   => __( 'Add Copyright text', 'brifa' ),
        'before_widget' => '<div>',
        'after_widget'  => '</div>',
        'before_title'  => '',
        'after_title'   => '',
    ) );



    register_sidebar( array(
        'name'          => __( 'Sidebar search', 'brifa' ),
        'id'            => 'sidebar-1',
        'description'   => __( 'Add search widgets here.', 'brifa' ),
        'before_widget' => '<div id="%1$s" class="blog_search %2$s">',
        'after_widget'  => '</div>',
        'before_title'  => '<h2 class="widget-title">',
        'after_title'   => '</h2>',
    ) );




}

add_action( "widgets_init", "brifa_widgets" );


function wpdocs_custom_excerpt_length( $length ) {
    return 20;
}
add_filter( 'excerpt_length', 'wpdocs_custom_excerpt_length', 999 );


function brifa_pagination() {

global $wp_query;

if ( $wp_query->max_num_pages <= 1 ) return; 

$big = 999999999; // need an unlikely integer

$pages = paginate_links( array(
        'base' => str_replace( $big, '%#%', esc_url( get_pagenum_link( $big ) ) ),
        'format' => '?paged=%#%',
        'current' => max( 1, get_query_var('paged') ),
        'total' => $wp_query->max_num_pages,
        'type'  => 'array',
    ) );
    if( is_array( $pages ) ) {
        $paged = ( get_query_var('paged') == 0 ) ? 1 : get_query_var('paged');
        echo '<div class="pagination-wrap"><ul class="pagination">';
        foreach ( $pages as $page ) {
                echo "<li>$page</li>";
        }
       echo '</ul></div>';
        }
}


