<?php
/**
 * Template Name: About Us Page
 */

get_header();


 $brifa_page_meta = get_post_meta(get_the_ID(),'page-upload-bg',true);
 $brifa_custom_bg = wp_get_attachment_image_src( $brifa_page_meta['page-image'], 'full' );
 $brifa_page_meta_one = get_post_meta(get_the_ID(),'brifa-page-about',true);
 $brifa_page_meta_two = get_post_meta(get_the_ID(),'brifa-page-about-two',true);



 $brifa_page_meta_team = get_post_meta(get_the_ID(),'brifa-about-teams',true);
 ?>

 <!--single page banner-->
    <header class="single-page-banner banner-blog" <?php if ( !empty( $brifa_custom_bg ) ): ?>style="background-image: url(<?php echo esc_url( $brifa_custom_bg[0] ); ?>);" <?php endif; ?>>

        <div class="container">
            <div class="page-banner-txt">


            

                <?php if(function_exists('bcn_display'))
                    {
                        bcn_display();
                    };
                    ?>
            </div><!--/.page-banner-txt-->
        </div><!--/.container-->
    </header>
    <!--/.single page banner-->

    <?php the_content(); ?>

    <!--about page content-->
    <section class="about-page-content">
        <div class="container">
            <div class="row">
                <div class="col-md-6">
                    <div class="about-inside-img">
                        <?php  

                            $brifa_about_left_one = wp_get_attachment_image_src( $brifa_page_meta_one['page-left-one'], 'full' ); 
                            $brifa_about_left_two = wp_get_attachment_image_src( $brifa_page_meta_one['page-left-two'], 'full' ); 
                            $brifa_about_left_three = wp_get_attachment_image_src( $brifa_page_meta_one['page-left-three'], 'full' ); 

                        ?>
                        <div class="img-1">
                            <figure>
                                <img src="<?php echo esc_url( $brifa_about_left_one[0] ); ?>" alt="<?php echo esc_html($brifa_page_meta_one['page-left-title']) ?>"/>
                            </figure>
                        </div>
                        <div class="img-2">
                            <figure>
                                <img src="<?php echo esc_url( $brifa_about_left_two[0] ); ?>" alt="<?php echo esc_html($brifa_page_meta_one['page-left-title']) ?>"/>
                            </figure>
                        </div>
                        <div class="img-3 wow animate fadeInLeft">
                            <figure>
                                <img src="<?php echo esc_url( $brifa_about_left_three[0] ); ?>" alt="<?php echo esc_html($brifa_page_meta_one['page-left-title']) ?>"/>
                            </figure>
                        </div>

                    </div><!--/.about-inside-img-->
                </div>
                <div class="col-md-6">
                    <div class="row h-100">
                        <div class="col-md-12 align-self-center">
                            <div class="about-text">
                                <h3><?php echo esc_html($brifa_page_meta_one['page-left-title']) ?></h3>
                                <?php echo wp_kses_post($brifa_page_meta_one['page-left-content']) ?>
                            </div><!--/.about-text-->
                        </div>
                    </div>
                </div>
                <div class="w-100 mt-3 mb-3"></div>
                <div class="col-md-6">
                    <div class="row h-100">
                        <div class="col-md-12 align-self-center">
                            <div class="about-text">
                                <h3><?php echo esc_html($brifa_page_meta_two['page-right-title']) ?></h3>
                                <?php echo wp_kses_post($brifa_page_meta_two['page-right-content']) ?>
                            </div><!--/.about-text-->
                        </div>
                    </div>
                </div>

                <div class="col-md-6">
                    <div class="about-inside-img">
                        <?php  

                            $brifa_about_right_one = wp_get_attachment_image_src( $brifa_page_meta_two['page-right-one'], 'full' ); 
                            $brifa_about_right_two = wp_get_attachment_image_src( $brifa_page_meta_two['page-right-two'], 'full' ); 
                            $brifa_about_right_three = wp_get_attachment_image_src( $brifa_page_meta_two['page-right-three'], 'full' ); 

                        ?>

                        <div class="img-1">
                            <figure>
                                <img src="<?php echo esc_url( $brifa_about_right_one[0] ); ?>" alt="<?php echo esc_html($brifa_page_meta_two['page-right-title']) ?>"/>
                            </figure>
                        </div>
                        <div class="img-2">
                            <figure>
                                <img src="<?php echo esc_url( $brifa_about_right_two[0] ); ?>" alt="<?php echo esc_html($brifa_page_meta_two['page-right-title']) ?>"/>
                            </figure>
                        </div>
                        <div class="img-3 wow animate fadeInRight">
                            <figure>
                                <img src="<?php echo esc_url( $brifa_about_right_three[0] ); ?>" alt="<?php echo esc_html($brifa_page_meta_two['page-right-title']) ?>"/>
                            </figure>
                        </div>
                    </div><!--/.about-inside-img-->
                </div>
            </div>
        </div><!--/.container-->
    </section>
    <!--/.about page content-->

    



    <!--bisa-team-member-->
    <section class="bisa-teams">
        <div class="container">
            <div class="row">
                <div class="col-md-8 offset-md-2">
                    <div class="title team-title">
                        <h3><?php echo esc_html($brifa_page_meta_team['team_member_title']['team_title_about']); ?></h3>
                        <p><?php echo esc_html($brifa_page_meta_team['team_member_title']['team_title_sub']); ?></p>
                    </div><!--/.title-->
                </div>
                <div class="w-100"></div>

                <?php
                $brifa_team_member = $brifa_page_meta_team['team_member_about'];
                if($brifa_team_member):

                 foreach ($brifa_team_member as $brifa_team_members): 
                         $brifa_team_img = wp_get_attachment_image_src( $brifa_team_members['brifa_team_img'], 'full' );
                
                        ?>
                        
                <div class="col-md-4">
                    <div class="team-inside">
                        <div class="item-inner">
                            <img src="<?php echo esc_url( $brifa_team_img[0] ); ?>" alt="<?php echo esc_html($brifa_team_members['team_name']); ?>"/>
                            <div class="overlay">
                                <div class="view-list">
                                    <div class="item-text">
                                        <ul>
                                            <?php if ( $brifa_team_members['social_profiles']['facebook'] ): ?>
                                            <li><a href="<?php echo esc_url($brifa_team_members['social_profiles']['facebook']) ?>"><i class="fab fa-facebook-f"></i></a></li>
                                            <?php endif; ?>
                                            <?php if ( $brifa_team_members['social_profiles']['twitter'] ): ?>
                                            <li><a href="<?php echo esc_url($brifa_team_members['social_profiles']['twitter']) ?>"><i class="fab fa-twitter"></i></a></li>
                                            <?php endif; ?>
                                            <?php if ( $brifa_team_members['social_profiles']['google_plus'] ): ?>
                                            <li><a href="<?php echo esc_url($brifa_team_members['social_profiles']['google_plus']) ?>"><i class="fab fa-google-plus-g"></i></a></li>
                                            <?php endif; ?>
                                        </ul>
                                    </div>
                                </div>
                            </div>           
                        </div><!--/.item-inner-->
                        <div class="team-info">
                            <h3><?php echo esc_html($brifa_team_members['team_name']); ?></h3>
                            <h5><?php echo esc_html($brifa_team_members['team_title']); ?></h5>
                        </div>
                    </div><!--/.team-inside-->
                </div>
                <?php endforeach; ?>

                <?php endif; ?>

            </div>
        </div><!--/.container-->
    </section>
    <!--/.bisa-team-member-->


    <?php get_footer(); ?>